'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('babel-polyfill');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _babelPluginSyntaxFlow = require('babel-plugin-syntax-flow');

var _babelPluginSyntaxFlow2 = _interopRequireDefault(_babelPluginSyntaxFlow);

var _camelcase = require('camelcase');

var _camelcase2 = _interopRequireDefault(_camelcase);

var _babelLooksLike = require('babel-looks-like');

var _babelLooksLike2 = _interopRequireDefault(_babelLooksLike);

var _s2sHelperGetReducerCase = require('s2s-helper-get-reducer-case');

var _s2sHelperGetReducerCase2 = _interopRequireDefault(_s2sHelperGetReducerCase);

var _s2sHelperGetInitialState = require('s2s-helper-get-initial-state');

var _s2sHelperGetInitialState2 = _interopRequireDefault(_s2sHelperGetInitialState);

var _s2sUtils = require('s2s-utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import blog from 'babel-log'

/* ::
import type {Path, State} from 's2s-babel-flow-types'
*/

// eslint-disable-line import/no-unassigned-import
const testBuilder = (0, _s2sUtils.template)(`
test(TEST_TITLE, () => {
  expect(reducer(initialState, actions.ACTION())).toEqual(STATE)
})
`);

exports.default = () => {
  return {
    inherits: _babelPluginSyntaxFlow2.default,
    name: 's2s-reducer-test-case',
    visitor: {
      Program(rootPath /* : Path */, { opts: { from } /* : State */ }) {
        if (!from) {
          throw new Error('required from option');
        }

        const existTestCases = [];
        rootPath.traverse({
          CallExpression(callPath /* : Path */) {
            if ((0, _babelLooksLike2.default)(callPath, {
              node: {
                callee: { type: 'Identifier', name: 'test' }
              }
            })) {
              const testTitlePath = callPath.get('arguments')[0];
              const value /* : string */ = testTitlePath.get('value').node;
              existTestCases.push(value.replace('handle ', ''));
            }
          }
        });

        const code = _fs2.default.readFileSync(from, 'utf8');
        const state = (0, _s2sHelperGetInitialState2.default)(code) || t.nullLiteral();

        function add(actionType /* : string */) {
          rootPath.pushContainer('body', [t.noop(), testBuilder({
            TEST_TITLE: t.stringLiteral(`handle ${actionType}`),
            ACTION: t.identifier((0, _camelcase2.default)(actionType)),
            STATE: state
          })]);
        }

        const actions = (0, _s2sHelperGetReducerCase2.default)(code);

        actions.filter(v => !existTestCases.includes(v)).forEach(add);
      }
    }
  };
};